from network import LoRa
from machine import Pin,ADC,reset,deepsleep
from onewire import DS18X20
from onewire import OneWire
from settings import app_eui, app_key
#from settings import dev_addr, nwk_swkey, app_swkey
from boot import Logger
import _thread
from pycom import nvs_set,nvs_get,rgbled
import socket
from binascii import hexlify
import cayenneLPP
from time import sleep
LOGGING = False
logger = Logger("SessionLog.txt")
logger.logging = LOGGING
Lora_join = 0
Read_battery = 0
R_temperature = 0
Temperature_int = -99
#Internal_temperature_int = 0
Battery_int = 0
global_status = 0









def Current_Battery_Voltage(debug=True):
    adc = ADC()
    adc.init(bits=10)
    #adc.vref_to_pin('P22')
    adc.vref(1115)
    Channel = adc.channel(pin='P13', attn = ADC.ATTN_0DB)
    Current_Battery_Reading = Channel.voltage()
    if debug:
     print(Current_Battery_Reading)
    Current_Battery = Current_Battery_Reading*11.155
    Current_Battery = int(Current_Battery)
    Channel.deinit()
    adc.deinit()
    return Current_Battery

def Send_Data():
    #counter = int(lora.stats()[8])
    # if counter == 1:
    #     logger.clear()
    while True:
     # print("R_temp: "+str(R_temperature))
     #
     # print("Read_Battery: "+ str(Read_battery))
     # print("Lora_join:" + str(Lora_join))
     if R_temperature == 1 and Read_battery == 1 and Lora_join == 1:
        rgbled(0x007f00)
        s = socket.socket(socket.AF_LORA, socket.SOCK_RAW)
        #s.setsockopt(socket.SOL_LORA, socket.SO_DR,0)
        s.setblocking(False)
        # creating Cayenne LPP packet
        lpp = cayenneLPP.CayenneLPP(size = 100, sock = s)
        #pycom.rgbled(0x007f00)
        print(lora.stats())
        counter = nvs_get("Counter")
        print(counter)
        status = global_status
        bat_val = Battery_int/1000
        temperature = Temperature_int
        #internal_temperature = Internal_temperature_int
        logger.write("Counter:"+ str(counter))
        s.setblocking(True)
        logger.write("Reading Battery")
        logger.write("Read Battery")
        print("Status: "+str(status))
        nvs_set("Temp_c",0)
        logger.write("Adding external temperature to payload")
        lpp.add_temperature(temperature)
        logger.write("Adding voltage to payload")
        lpp.add_analog_output(bat_val)
        logger.write("Adding status to payload")
        lpp.add_digital_output(status)
        #logger.write("Adding internal temperature to payload")
        #lpp.add_temperature(internal_temperature)
        logger.write("Sending payload")
        lpp.send(reset_payload = True)
        logger.write("Saving LoRa to NVRAM")
        lora.nvram_save()
        print(temperature)
        #logger.write("Temperature read and sent: "+str(temperature))
        #logger.write("Voltage read: "+str(bat_val))
        logger.write("NVRAM saved")
        print("Sensor Battery : ",bat_val,'V')
        nvs_set("Counter",counter+1)
        print("Entering sleep.")
        logger.write("Entering sleep")
        rgbled(0x000000)
        if status == 1:
            deepsleep(900000)
            #time.sleep(15)
        elif status == 0:
            deepsleep(60000)
            #time.sleep(30)
        break
    _thread.exit()

def Read_Temperature():
    print("Start temperature thread")
    try:
        temp_retry_counter = nvs_get("Temp_c")
    except:
        nvs_set("Temp_c",0)
        temp_retry_counter = nvs_get("Temp_c")

    ow = OneWire(Pin('P10'))
    temp = DS18X20(ow)
    status = 0
    temperature = -99
    internal_temperature = -99
    try:
     status = 1
     logger.write("Reading Temperature")
     temperature = temp.read_temp_async()/100
     #internal_temperature = temp.read_temp_async(rom=temp.roms[1])/100
     #temp.start_conversion(rom=temp.roms[1])
     temp.start_conversion()
     if  temperature == 85.00 or internal_temperature==85.00:
         sleep(1)
         temperature = temp.read_temp_async()/100
         #internal_temperature = temp.read_temp_async(rom=temp.roms[1])/100
         #temp.start_conversion(rom=temp.roms[1])
         temp.start_conversion()
    except Exception as e:
     status = 0
     rgbled(0x000000)
     rgbled(0xFF0000)
     logger.write("Read temperature failed, retrying.")
     logger.write(str(e))
     try:
       status = 1
       temperature = temp.read_temp_async()/100
       #internal_temperature = temp.read_temp_async(rom=temp.roms[1])/100
       #temp.start_conversion(rom=temp.roms[1])
       temp.start_conversion()
       if  temperature == 85.00 or internal_temperature==85.00:
           sleep(1)
           #internal_temperature = temp.read_temp_async(rom=temp.roms[1])/100
           temperature = temp.read_temp_async()/100
           #temp.start_conversion(rom=temp.roms[1])
           temp.start_conversion()
     except Exception as e:
        status = 0
        rgbled(0xFF0000)
        logger.write("Retry failed, reseting.")
        logger.write(str(e))
        nvs_set("Temp_c",temp_retry_counter + 1)
        rgbled(0x000000)
        if temp_retry_counter < 5:
         reset()
        pass
     pass
    print("Temperature integer: " + str(temperature))
    global Temperature_int
    Temperature_int = temperature
    #global Internal_temperature_int
    #Internal_temperature_int = internal_temperature
    global global_status
    global_status = status
    global R_temperature
    R_temperature = 1
    _thread.exit()


def Join_Load_Lora():
    print("Starting Lora")
    # Initialize LoRa in LORAWAN mode.
    global lora
    lora = LoRa(mode=LoRa.LORAWAN , region=LoRa.AU915,adr=True)
    logger.write("Intialized Lora")
    lora.nvram_restore()
    logger.write("Lora restored from NVRAM, if stored")
    # Retrieve the dev_eui from the LoRa chip (Only needed for OTAA to retrieve once)
    dev_eui = hexlify(lora.mac()).upper().decode('utf-8')

    for index in (list(range(0,8))+list(range(16,65))+list(range(66,72))): lora.remove_channel(index)

    # Join a network using OTAA (Over the Air Activation)
    if not lora.has_joined():
        nvs_set("Counter",0)
        #pycom.nvs_set("Temp_c",0)
        #lora.join(activation=LoRa.ABP, auth=(dev_addr, nwk_swkey, app_swkey))
        lora.join(activation=LoRa.OTAA, auth=(app_eui, app_key), timeout=0)
    counter = nvs_get("Counter")
    if counter%96 == 0 and counter > 0 :
        lora = LoRa(mode=LoRa.LORAWAN , region=LoRa.AU915,adr=True)
        #lora.join(activation=LoRa.ABP, auth=(dev_addr, nwk_swkey, app_swkey))
        lora.join(activation=LoRa.OTAA, auth=(app_eui, app_key), timeout=0)
        for index in (list(range(0,8))+list(range(16,65))+list(range(66,72))): lora.remove_channel(index)
    # Wait until the module has joined the network
    count = 0
    while not lora.has_joined():
        rgbled(0x0000ff) # Make the LED light up in blue
        sleep(0.2)
        rgbled(0x000000) # Make the LED light up in black
        sleep(2)
        print("retry join count is:" ,  count)
        logger.write("retry join count is:" +  str(count))
        count = count + 1
        if count > 100:
            deepsleep(120000)

    print("join procedure successful")
    # Show that LoRa OTAA has been succesfull by blinking blue
    global Lora_join
    Lora_join = 1
    logger.write("join procedure successful")

def Read_Battery():
     bat_val_mv =  Current_Battery_Voltage()
     global Battery_int
     Battery_int = bat_val_mv
     global Read_battery
     Read_battery = 1
     _thread.exit()


# creating Cayenne LPP packet
# creating some payloads and sending them
if __name__ == "__main__":
    _thread.start_new_thread(Read_Temperature,())
    _thread.start_new_thread(Read_Battery,())
    _thread.start_new_thread(Send_Data,())
    Join_Load_Lora()

# while True:
# sent = nvs_get("Sent_Data")
# if sent == 1:
#  machine.deepsleep(60000)
